def prueba( A, i, j, k ) :
	# Los tres puntos de comparación son
	# 'i', 'j' y 'k'
	#
	ux = A[k][0] - A[j][0]
	uy = A[k][1] - A[j][1]

	vx = A[i][0] - A[j][0]
	vy = A[i][1] - A[j][1]

	return  ux*vy - vx*uy

# Comparación de tres puntos para ordenarlos
# en forma circular
def comparacion( A, i, j ) :
	# Los tres puntos de comparación son
	# '0', 'i' y 'j'
	#
	ux = A[i][0] - A[0][0]
	uy = A[i][1] - A[0][1]

	vx = A[j][0] - A[0][0]
	vy = A[j][1] - A[0][1]

	return  ux*vy - vx*uy

# Pseudocódigo del ordenamiento por inserción
def ordenar_por_insercion_horario( A, idx  ) :
	n = len( idx )
	j = 1
	while j<n :
		print( "j:", j )
		key = idx[j]
		# Inserta A[j] en la secuencia ordenada A[1..j-1]
		i = j - 1
		while i >= 0 :
			print( "i:", i )
			c = comparacion( A, idx[i], key )
			if c > 0 :
				print( idx[i], idx[j], c )
				idx[i+1] = idx[i]
				i -= 1
			else :
				break

		idx[i+1] = key 

		print( idx )
		j += 1

	return idx

# Pseudocódigo del ordenamiento por inserción
def ordenar_por_insercion( A, idx  ) :
	n = len( idx )
	j = 1
	while j<n :
		key = idx[j]
		# Inserta A[j] en la secuencia ordenada A[1..j-1]
		i = j - 1
		while i >= 0 and comparacion( A, idx[i], key ) < 0 :
			idx[i+1] = idx[i]
			i -= 1

		idx[i+1] = key 

		j += 1
